Bug 1259416 - Review Request: pipewire - Share cameras and other multimedia streams
Review Request: pipewire - Share cameras and other multimedia streams
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David King
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-09-02 10:29 EDT by Wim Taymans
Modified: 2017-12-11 10:17 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
amigadave: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Wim Taymans 2015-09-02 10:29:58 EDT
Spec URL: http://people.freedesktop.org/~wtay/SPECS/pinos.spec
SRPM URL: http://people.freedesktop.org/~wtay/SRPMS/pinos-0.1-1.fc22.src.rpm
Description: Pinos allows applications to share multimedia devices and streams
Fedora Account System Username: wtaymans
Comment 1 David King 2015-09-04 11:29:42 EDT
fedora-review won't build the spec in mock for me (you might be missing a gstreamer1-plugins-base-devel BuildRequires). Anyway, some comments:

* it's best to use the pkgconfig(foo) for for BuildRequires if suitable: https://fedoraproject.org/wiki/Packaging:PkgConfigBuildRequires
* for users and groups (I guess that the groups do not exist by default): https://fedoraproject.org/wiki/Packaging:UsersAndGroups
* licensing documents must use %license, not %doc: https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text
Comment 2 Wim Taymans 2015-09-09 11:23:18 EDT
Thanks for review, I updated the files with your suggestions. Here:

Spec URL: http://people.freedesktop.org/~wtay/SPECS/pinos.spec
SRPM URL: http://people.freedesktop.org/~wtay/SRPMS/pinos-0.1-2.fc22.src.rpm
Comment 3 David King 2015-09-10 05:22:36 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines

No idea why this happens, but probably fixing some of the other problems will help. :-)

- Package does not contain any libtool archives (.la)
  Note: pinos : /usr/lib64/gstreamer-1.0/libgstpinos.la
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

Easy enough to extend the existing .la file removal (if the .la file is really not required).

- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.

You can check the validity of the autostart file with desktop-file-validate in %check (for example).

- Unversioned .so files in libdir.

https://fedoraproject.org/wiki/Packaging:Guidelines#Downstream_.so_name_versioning says that these should be versioned with the usual libtool versioning stuff (although it is only a SHOULD). Then, the unversioned shared object can go in the -devel package, while keeping the versioned library in the -libs package. Currently, the -lib subpackage seems empty, except for some documentation, and this is likely not intended.

- Bad version numbers in changelog

The version numbers should match those in the spec header.

- GPL license text not needed. The only GPLv2 code in the tarball is the libtool script and xmltoman files, which are only used at build time. Therefore, you do not need to install the GPL text (and if you did, it would need to be part of the Licence tag anyway).

- URL gives a 404

Would be good if this page could exist, otherwise it is best to just omit the field.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v2 or later)", "LGPL (v2 or later)", "GPL
     (v2 or later)", "LGPL (v2 or later) (with incorrect FSF address)",
     "Unknown or generated". 5 files have unknown license. Detailed output
     of licensecheck in
     /home/david/checkout/rpms/1259416-pinos/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /etc/dbus-1/system.d
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /etc/dbus-1/system.d

Should be owned by the dbus package, so not pinos' problem.

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     http://freedesktop.org/software/pinos/releases/pinos-0.1.tar.xz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in pinos-
     libs , pinos-libs-devel , pinos-utils , pinos-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.12 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.12
INFO: Mock Version: 1.2.12
Finish: chroot init
INFO: installing package(s): /home/david/checkout/rpms/1259416-pinos/results/pinos-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-libs-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-libs-devel-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-utils-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-debuginfo-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-debuginfo-0.1-2.fc24.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 install /home/david/checkout/rpms/1259416-pinos/results/pinos-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-libs-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-libs-devel-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-utils-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-debuginfo-0.1-2.fc24.x86_64.rpm /home/david/checkout/rpms/1259416-pinos/results/pinos-debuginfo-0.1-2.fc24.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: pinos-0.1-2.fc24.x86_64.rpm
          pinos-libs-0.1-2.fc24.x86_64.rpm
          pinos-libs-devel-0.1-2.fc24.x86_64.rpm
          pinos-utils-0.1-2.fc24.x86_64.rpm
          pinos-debuginfo-0.1-2.fc24.x86_64.rpm
          pinos-0.1-2.fc24.src.rpm
pinos.x86_64: W: incoherent-version-in-changelog 0.1.0-2 ['0.1-2.fc24', '0.1-2']
pinos.x86_64: W: invalid-url URL: http://www.freedesktop.org/wiki/Software/Pinos HTTP Error 404: Not Found
pinos.x86_64: W: devel-file-in-non-devel-package /usr/lib64/gstreamer-1.0/libgstpinos.so
pinos.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/pinos-system.conf
pinos.x86_64: W: non-conffile-in-etc /etc/xdg/autostart/pinos.desktop
pinos-libs.x86_64: W: spelling-error %description -l en_US runtime -> run time, run-time, rudiment
pinos-libs.x86_64: W: invalid-url URL: http://www.freedesktop.org/wiki/Software/Pinos HTTP Error 404: Not Found
pinos-libs-devel.x86_64: W: invalid-url URL: http://www.freedesktop.org/wiki/Software/Pinos HTTP Error 404: Not Found
pinos-libs-devel.x86_64: W: only-non-binary-in-usr-lib
pinos-libs-devel.x86_64: W: no-documentation
pinos-utils.x86_64: W: invalid-url URL: http://www.freedesktop.org/wiki/Software/Pinos HTTP Error 404: Not Found
pinos-debuginfo.x86_64: W: invalid-url URL: http://www.freedesktop.org/wiki/Software/Pinos HTTP Error 404: Not Found
pinos.src: W: invalid-url URL: http://www.freedesktop.org/wiki/Software/Pinos HTTP Error 404: Not Found
pinos.src:6: W: macro-in-comment %{gitcommit}
pinos.src:22: W: macro-in-comment %{gitcommit}
pinos.src:139: W: macro-in-comment %{_sysconfdir}
pinos.src:150: W: macro-in-comment %dir
pinos.src:150: W: macro-in-comment %{_sysconfdir}
pinos.src:151: W: macro-in-comment %dir
pinos.src:151: W: macro-in-comment %{_libdir}
pinos.src: E: specfile-error warning: Macro expanded in comment on line 6: #global shortcommit %(c=%{gitcommit}; echo ${c:0:5})
pinos.src: E: specfile-error 
pinos.src: E: specfile-error warning: Macro expanded in comment on line 139: #dir %{_sysconfdir}/pinos/
pinos.src: E: specfile-error 
pinos.src: E: specfile-error warning: Macro expanded in comment on line 150: #%dir %{_sysconfdir}/pinos/
pinos.src: E: specfile-error 
pinos.src: E: specfile-error warning: Macro expanded in comment on line 151: #%dir %{_libdir}/pinos/
6 packages and 0 specfiles checked; 7 errors, 20 warnings.




Requires
--------
pinos-utils (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgstallocators-1.0.so.0()(64bit)
    libgstbase-1.0.so.0()(64bit)
    libgstnet-1.0.so.0()(64bit)
    libgstreamer-1.0.so.0()(64bit)
    libpinos-0.1.so()(64bit)
    libpthread.so.0()(64bit)
    pinos-libs(x86-64)
    rtld(GNU_HASH)

pinos-libs (rpmlib, GLIBC filtered):

pinos-debuginfo (rpmlib, GLIBC filtered):

pinos-libs-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    pinos-libs(x86-64)

pinos (rpmlib, GLIBC filtered):
    /bin/sh
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgstallocators-1.0.so.0()(64bit)
    libgstbase-1.0.so.0()(64bit)
    libgstnet-1.0.so.0()(64bit)
    libgstpinos.so.0()(64bit)
    libgstreamer-1.0.so.0()(64bit)
    libgstvideo-1.0.so.0()(64bit)
    libltdl.so.7()(64bit)
    libpinos-0.1.so()(64bit)
    libpinoscore-0.1.so()(64bit)
    libpthread.so.0()(64bit)
    pinos-libs(x86-64)
    rtkit
    rtld(GNU_HASH)
    shadow-utils
    systemd



Provides
--------
pinos-utils:
    pinos-utils
    pinos-utils(x86-64)

pinos-libs:
    pinos-libs
    pinos-libs(x86-64)

pinos-debuginfo:
    pinos-debuginfo
    pinos-debuginfo(x86-64)

pinos-libs-devel:
    pinos-libs-devel
    pinos-libs-devel(x86-64)
    pkgconfig(libpinos)

pinos:
    gstreamer1(element-pinosdepay)()(64bit)
    gstreamer1(element-pinospay)()(64bit)
    gstreamer1(element-pinossink)()(64bit)
    gstreamer1(element-pinossrc)()(64bit)
    libgstpinos.so.0()(64bit)
    libpinos-0.1.so()(64bit)
    libpinoscore-0.1.so()(64bit)
    libtool(/usr/lib64/gstreamer-1.0/libgstpinos.la)
    pinos
    pinos(x86-64)



Unversioned so-files
--------------------
pinos: /usr/lib64/gstreamer-1.0/libgstpinos.so
pinos: /usr/lib64/libpinos-0.1.so
pinos: /usr/lib64/libpinoscore-0.1.so

Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1259416
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 4 Wim Taymans 2017-06-20 07:15:51 EDT
Name change Pinos -> PipeWire Spec and SRPM for review:

https://people.freedesktop.org/~wtay/SPECS/pipewire.spec
https://people.freedesktop.org/~wtay/SRPMS/pipewire-0.1.0-2.fc25.src.rpm
Comment 5 David King 2017-06-20 08:45:56 EDT
Missing a "BuildRequires: pkgconfig(dbus-1)" by the looks of it:

Meson encountered an error in file meson.build, line 134, column 0:
Native dependency 'dbus-1' not found
Comment 6 Neal Gompa 2017-06-20 21:36:49 EDT
Please don't call the devel subpackage "libs-devel". Just call it "devel", as that's the convention that is expected.
Comment 8 David King 2017-07-03 01:47:09 EDT
While trying to build in mock (as part of a fedora-review run):

Native dependency dbus-1 found: YES 1.11.14
Native dependency gstreamer-1.0 found: YES 1.12.1
Native dependency gstreamer-plugins-base-1.0 found: YES 1.12.1
Native dependency gstreamer-video-1.0 found: YES 1.12.1
Native dependency gstreamer-audio-1.0 found: YES 1.12.1
Native dependency gstreamer-allocators-1.0 found: YES 1.12.1
Meson encountered an error in file spa/meson.build, line 3, column 0:
Native dependency 'alsa' not found

Can you add the dependency and try building in mock before submitting again?
Comment 9 Wim Taymans 2017-07-04 09:52:47 EDT
New links for new version, tested with fedpkg mockbuild

https://people.freedesktop.org/~wtay/SPECS/pipewire.spec
https://people.freedesktop.org/~wtay/SRPMS/pipewire-0.1.2-1.fc27.src.rpm
Comment 10 David King 2017-07-05 14:31:41 EDT
I ran fedora-review, and it came up with:

Issues:
=======
- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 22579200 bytes in 784 files.
  See:
  http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

Once that's fixed, ready to go!
Comment 12 David King 2017-08-09 05:25:41 EDT
Looks good to me!
Comment 13 Gwyn Ciesla 2017-08-15 11:59:04 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/pipewire
Comment 14 Gwyn Ciesla 2017-08-15 11:59:39 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/pipewire

Note You need to log in before you can comment on or make changes to this bug.